package com.daylight;

import com.daylight.Smiles;
public class Http {

    /* functions */
    private static native int jdt_alloc_http_server(int port);
    public static int dt_alloc_http_server(int port) {
        synchronized(Smiles.LockObject) {
            return jdt_alloc_http_server(port);
	}
    }

    private static native int jdt_http_get(int http);
    public static int dt_http_get(int http) {
        synchronized(Smiles.LockObject) {
            return jdt_http_get(http);
	}
    }

    private static native boolean jdt_http_put(int transfer);
    public static boolean dt_http_put(int transfer) {
        synchronized(Smiles.LockObject) {
            return jdt_http_put(transfer);
	}
    }

    /* End of functions */

    // Constants

    // properties used per call to dt_http_get() */
    // http_status */
    public static final int DX_HTT_TIMEOUT       =  0;
    public static final int DX_HTT_OK            =  1;
    public static final int DX_HTT_DONE          =  2;
    public static final int DX_HTT_ERROR         = -1;

    // Property Names */
    // Read-Only Properties of a CGI/Server (HTTP object) */
    public static final String DX_HTT_DATE           ="htt_date";
    public static final String DX_HTT_HOST           ="htt_host";
    public static final String DX_HTT_LIPS           ="htt_lips";
    public static final String DX_HTT_PORT           ="htt_port";
    public static final String DX_HTT_STATUS         ="htt_status";

    // Read-Write Properties of a CGI/Servier (HTTP object) */
    public static final String DX_HTT_METHODS        ="htt_methods";
    public static final String DX_HTT_TIMEOUT_MS     ="htt_timeout_ms";

    // Read-Only Properties of a Request (TRANSFER object) */
    public static final String DX_HTT_AGENT          ="htt_agent";
    public static final String DX_HTT_AUTHORIZE      ="htt_authorize";
    public static final String DX_HTT_FROM           ="htt_from";
    public static final String DX_HTT_METHOD_ID      ="htt_method_id";
    public static final String DX_HTT_METHOD         ="htt_method";
    public static final String DX_HTT_PATH           ="htt_path";
    public static final String DX_HTT_POST           ="htt_post";      // sequence of strings */
    public static final String DX_HTT_PROTOCOL       ="htt_protocol";
    public static final String DX_HTT_RAWHEAD        ="htt_rawhead";   // original HEAD data */
    public static final String DX_HTT_RAWPOST        ="htt_rawpost";   // original POST data */
    public static final String DX_HTT_RECV_          ="htt_recv_";     // special prefix for "other" */
    public static final String DX_HTT_REFERER        ="htt_referer";
    public static final String DX_HTT_RIPS           ="htt_rips";
    public static final String DX_HTT_SINCE          ="htt_since";

    // Read-Write Properties of a Response (TRANSFER object) */
    public static final String DX_HTT_AUTHENTICATE   ="htt_authenticate";
    public static final String DX_HTT_CODE           ="htt_code";
    public static final String DX_HTT_CONTENT        ="htt_content";
    //reuse DX_HTT_DATE           "htt_date"*/
    public static final String DX_HTT_ENCODING       ="htt_encoding";
    public static final String DX_HTT_EXPIRES        ="htt_expires";
    public static final String DX_HTT_LOCATION       ="htt_location";
    //reuse DX_HTT_METHOD_ID      "htt_method_id"*/
    public static final String DX_HTT_MIME_TYPE      ="htt_mime_type";
    public static final String DX_HTT_MODIFIED       ="htt_modified";
    public static final String DX_HTT_PRAGMA         ="htt_pragma";
    public static final String DX_HTT_SEND_          ="htt_send_";
    public static final String DX_HTT_SERVICE        ="htt_service";
    public static final String DX_HTT_VERSION        ="htt_version";
    // HTML Presentation Properties */
    public static final String DX_HTM_AUTOHTML       ="htm_autohtml";
    public static final String DX_HTM_BODY_BG_COLOR  ="htm_body_bg_color";
    public static final String DX_HTM_BODY_BG_IMAGE  ="htm_body_bg_image";
    public static final String DX_HTM_BODY_TAG       ="htm_body_tag";
    public static final String DX_HTM_DOCTYPE_TAG    ="htm_doctype_tag";
    public static final String DX_HTM_HEAD_TAG       ="htm_head_tag";
    public static final String DX_HTM_HEAD_TITLE     ="htm_head_title";
    public static final String DX_HTM_HEAD_SCRIPT    ="htm_head_script";
    public static final String DX_HTM_HEAD_STYLE     ="htm_head_style";
    public static final String DX_HTM_POSTFIX        ="htm_postfix";
    public static final String DX_HTM_PREFIX         ="htm_prefix";

    // Property Names for DX_HTT_POST */
    public static final String DX_HTT_VALUE          ="htt_value";
    public static final String DX_HTT_FILENAME       ="htt_filename";
    //reuse DX_HTT_MIME_TYPE      "htt_mime_type"*/

    // definitions for "htt_method_id" property */
    public static final int DX_HTT_METHOD_ANY   = 0x00;
    public static final int DX_HTT_METHOD_NONE  = 0x00;
    public static final int DX_HTT_METHOD_HEAD  = 0x01;
    public static final int DX_HTT_METHOD_GET   = 0x02;
    public static final int DX_HTT_METHOD_POST  = 0x04;
    public static final int DX_HTT_METHOD_ALL   = 0x07;

    // end of constants

    static { System.loadLibrary("dj"); }

    /////////////// END
}
