//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import java.text.DecimalFormat;
import com.daylight.Smiles;
import com.daylight.Depict;

class calcxy extends Smiles {
    public static void main(String[] args) throws IOException {
	BufferedReader in = new BufferedReader
            (new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out, true);
	DecimalFormat df = new DecimalFormat("0.00");
	String line, tdt;
	int i, molecule, depiction, atoms, atom;
	float x[] = new float[1];
	float y[] = new float[1];
	float z[] = new float[1];

	// arguments
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new calcxy().getClass().getName() +
				   " < input.smi");
		System.exit(0);
	    }
	}

        // loop over input (read SMILES)
        while (null != (line=in.readLine())) {
            // get molecule
            if (NULL_OB == (molecule = Smiles.dt_smilin(line))) {
                System.err.println("WARNING: invalid SMILES (" + line + ")");
                continue;
            }

	    // get depiction
            if (NULL_OB == (depiction = Depict.dt_alloc_depiction(molecule))) {
                System.err.println("ERROR: dt_alloc_depiction failed ("
				   + line + ")");
		System.exit(1);
            }

	    // get layout
            if (false == Depict.dt_calcxy(depiction)) {
                System.err.println("ERROR: dt_calcxy failed (" + line + ")");
		System.exit(1);
            }

	    // show TDT - SMILES and 2D coordinates
	    // molecule or reaction
	    if (TYP_REACTION == Smiles.dt_type(molecule))
		tdt = new String("$SMI<\"" + line + "\">");
	    else
		tdt = new String("$SMI<" + line + ">");
	    // coordinates
	    tdt = tdt + new String("2D<");
	    i=0;
	    // get atoms
	    if (NULL_OB == (atoms = Smiles.dt_stream(molecule, TYP_ATOM))) {
                System.err.println("ERROR: dt_stream for atoms failed");
		System.exit(1);
	    }
	    // loop over atoms
	    while (NULL_OB != (atom = Smiles.dt_next(atoms))) {
		if (0 < i++)
		    tdt = tdt + new String(",");
		// get coordinate
		if (false == Depict.dt_getcoord(depiction, atom, x, y, z)) {
		    System.err.println("ERROR: unable to get coordinates");
		    System.exit(1);
		}
		// add to TDT string
		tdt = tdt + df.format(x[0]) + "," + df.format(y[0]);
	    }
	    tdt = tdt + new String(";>|");
	    // show TDT
	    out.println(tdt);

	    // deallocate
	    Smiles.dt_dealloc(depiction);
	    Smiles.dt_dealloc(molecule);
	}

	// close I/O
        out.close();
   }
}
