//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;
import com.daylight.Finger;

class setbitvalues extends Smiles {
    public static void main(String[] args) throws IOException {
	PrintWriter out = new PrintWriter(System.out, true);
	int i, j, k, max, fp;
	boolean stat;

	// arguments
	k = 32;
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new setbitvalues().getClass().getName() +
				   " <size> [ bitno bitno...]");
		System.exit(0);
	    }
	    // size
	    k = Integer.parseInt(args[0]);
	}

	// check value
	if (32 > k || k > 1073741824) {
	    System.err.println("ERROR: Fingerpint size out-of-range " +
			       "(32-1073741824)");
	    System.exit(1);
	}

	// allocate fingerprint
	if (NULL_OB == (fp = Finger.dt_fp_allocfp(k))) {
	    System.err.println("ERROR: unable to alloc Fingerprint");
	    System.exit(1);
	}
	max = k-1;

	// loop over remaining arguments (read bit numbers)
	for (i=1; i<args.length; i++) {
	    j = Integer.parseInt(args[i]);

	    // check value
	    if (0 > j || j > max) {
		System.err.println("Bit #" + j +
				   " is out-of-range (0-" + max + ")");
		continue;
	    }

	    // set bit number
	    if (true == (stat = Finger.dt_fp_setbitvalue(fp,j,true)))
		out.println("Bit #" + j + " is set.");
	}

	// show bits
	out.println("The " + k + "-bit Fingerprint values are:");
	for (i=0; i<k; i++)
	    out.print(1 == Finger.dt_fp_bitvalue(fp, i) ? "1" : "0");
	out.println();

	// close I/O
        out.close();
   }
}
