import java.io.*;
import com.daylight.Smiles;
import com.daylight.Http;

class http_cansmi extends Smiles {
    public static void main(String[] args) throws IOException {
	String name = new http_cansmi().getClass().getName();
	PrintWriter out = new PrintWriter(System.out, true);
	int http, xfer;
        int port;
	boolean stat=false;

	// arguments
	port = 8080;
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " + name + " <port>");
		System.exit(0);
	    }
	    // port
	    port = Integer.parseInt(args[0]);
	}

	// check value
	if (1 > args.length) {
	    out.println(name + ": missing integer argument");
	    System.exit(1);
	}
	if ((0 > port) || (65535 < port)) {
	    out.println(name + ": port number out-of-range (0-65535)");
	    System.exit(1);
	}

	// create a service */
	if (0 == (http = Http.dt_alloc_http_server(port))) {
	    out.println(name + ": dt_alloc_http_server failed\n");
	    System.exit(1);
	}

	for (;;) {
	    // receive a request */
	    xfer = Http.dt_http_get(http);

	    if (NULL_OB != xfer) {
		// process request, prepare response */
		my_handler(xfer);
		// send a response */
		stat = Http.dt_http_put(xfer);
		Smiles.dt_dealloc(xfer);
	    }

	    // run-once for CGI */
	    if (0 == port)
		break;	    
	}

	// close I/O
        out.close();

	// return success or failure
	if (!stat)
	    System.exit(1);
	System.exit(0);
    }

    public static int du_http_post(int xfer, int plen, String pname) {
	int sequence, string;
	byte[] value;

	// get property */
	sequence = Smiles.dt_handle(xfer, "htt_post");

	// loop over sequence, get strings */
	while (NULL_OB != (string = Smiles.dt_next(sequence))) {
	    // get value */
	    value = Smiles.dt_stringvalue(string);
	    // check for match */
	    if (true == new String(value).startsWith(pname))
		// return string value */
		return string;
	}

	// not found */
	return 0;
    }

    public static void du_http_form(int xfer, String name, String type,
				    String encoding, String action,
				    String button, int vlen, String value) {
	// begin form */
	Smiles.dt_appendstring(xfer, "htt_content",
			"<FORM METHOD=POST NAME=form ACTION=");
	// action */
	Smiles.dt_appendstring(xfer, "htt_content", action);
	// encoding */
	Smiles.dt_appendstring(xfer, "htt_content", " ENCTYPE=");
	Smiles.dt_appendstring(xfer, "htt_content", encoding);
	Smiles.dt_appendstring(xfer, "htt_content", ">\n");
	// label */
	Smiles.dt_appendstring(xfer, "htt_content", name);
	// name */
	Smiles.dt_appendstring(xfer, "htt_content", ": <INPUT NAME=");
	Smiles.dt_appendstring(xfer, "htt_content", name);
	// type */
	Smiles.dt_appendstring(xfer, "htt_content", " TYPE=");
	Smiles.dt_appendstring(xfer, "htt_content", type);
	// value */
	Smiles.dt_appendstring(xfer, "htt_content", " VALUE=");
	if(null != value)
	    Smiles.dt_appendstring(xfer, "htt_content", value);
	Smiles.dt_appendstring(xfer, "htt_content", ">\n");
	// button */
	if (null != button) {
	    Smiles.dt_appendstring(xfer, "htt_content", "<INPUT TYPE=BUTTON ");
	    Smiles.dt_appendstring(xfer, "htt_content", button);
	    Smiles.dt_appendstring(xfer, "htt_content", ">\n");
	}
	// end form */
	Smiles.dt_appendstring(xfer, "htt_content",
			"<INPUT TYPE=SUBMIT NAME=button>\n</FORM>\n");
    }

    public static void my_handler(int xfer) {
	int string;
	String path, value = null;
	int plen, vlen = 0;
	String name = "SMILES", type = "TEXT", action;
	String encoding = "application/x-www-form-urlencoding";

	/* get path and set action URL */
	path = Smiles.dt_string(xfer, "htt_path");
	if (null == (action = path)) {
	    action = "out-of-memory";
	    Smiles.dt_setstring(xfer, "htt_content", action);
	    Smiles.dt_setinteger(xfer, "htt_code", 500);
	}

	/* set return code and mime type */
	Smiles.dt_setinteger(xfer, "htt_code", 200);
	Smiles.dt_setstring (xfer, "htt_mime_type", "text/html");

	/* get POST data */
	if (NULL_OB != (string = du_http_post(xfer, 0, name)))
	    value = Smiles.dt_string(string, "htt_value");
	else
	    value = "";
	vlen = 0;

	/* write form */
	du_http_form(xfer, name, type, encoding, action, null, vlen, value);

	/* parse smiles and canonicalize */
	if (null != value ) {
	    int molecule;
	    String cansmiles;

	    if (NULL_OB != (molecule = Smiles.dt_smilin(value))) {
		cansmiles = Smiles.dt_cansmiles(molecule, true);
		/* set response */
		Smiles.dt_appendstring(xfer, "htt_content", "\n<P>Canonical SMILES: ");
		Smiles.dt_appendstring(xfer, "htt_content", cansmiles);
		Smiles.dt_appendstring(xfer, "htt_content", "\n");
	    }
	    Smiles.dt_dealloc(molecule);
	}
    }
}
