import java.io.*;
import com.daylight.Smiles;
import com.daylight.Http;

class http_hello_world extends Smiles {
    public static void main(String[] args) throws IOException {
	String name = new http_hello_world().getClass().getName();
	PrintWriter out = new PrintWriter(System.out, true);
	int http, xfer;
        int port;
	boolean stat=false;

	// arguments
	port = 8080;
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " + name + " <port>");
		System.exit(0);
	    }
	    // port
	    port = Integer.parseInt(args[0]);
	}

	// check value
	if (1 > args.length) {
	    out.println(name + ": missing integer argument");
	    System.exit(1);
	}
	if ((0 > port) || (65535 < port)) {
	    out.println(name + ": port number out-of-range (0-65535)");
	    System.exit(1);
	}

	// create a service */
	if (0 == (http = Http.dt_alloc_http_server(port))) {
	    out.println(name + ": dt_alloc_http_server failed\n");
	    System.exit(1);
	}

	for (;;) {
	    // receive a request */
	    xfer = Http.dt_http_get(http);

	    if (NULL_OB != xfer) {
		// process request, prepare response */
		my_handler(xfer);
		// send a response */
		stat = Http.dt_http_put(xfer);
		Smiles.dt_dealloc(xfer);
	    }

	    // run-once for CGI */
	    if (0 == port)
		break;	    
	}

	// close I/O
        out.close();

	// return success or failure
	if (!stat)
	    System.exit(1);
	System.exit(0);
    }

    public static void my_handler(int xfer) {
	String method, path, protocol;

	method   = dt_string(xfer, "htt_method");
	path     = dt_string(xfer, "htt_path");
	protocol = dt_string(xfer, "htt_protocol");

	dt_setinteger   (xfer, "htt_code",     200);
	dt_setstring    (xfer, "htt_mime_type", "text/html");
	dt_setstring    (xfer, "htt_content", "Hello World!");
	dt_appendstring (xfer, "htt_content", "\n\nMethod:   ");
	dt_appendstring (xfer, "htt_content", method);
	dt_appendstring (xfer, "htt_content", "\nPath:     ");
	dt_appendstring (xfer, "htt_content", path);
	dt_appendstring (xfer, "htt_content", "\nProtocol: ");
	dt_appendstring (xfer, "htt_content", protocol);
	dt_appendstring (xfer, "htt_content", "\n");
    }
}
