//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;
import com.daylight.Http;

class test_http_server extends Smiles {
    public static void main(String[] args) throws IOException {
	String name = new test_http_server().getClass().getName();
	PrintWriter out = new PrintWriter(System.out, true);
	int http, xfer;
        int port;

	// arguments
	port = 8080;
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " + name + " <port>");
		System.exit(0);
	    }
	    // port
	    port = Integer.parseInt(args[0]);
	}

	// check value
	if (1 > args.length) {
	    System.err.println(name + ": missing integer argument");
	    System.exit(1);
	}
	if ((0 >= port) || (65535 < port)) {
	    System.err.println(name + ": port number out-of-range (1-65535)");
	    System.exit(1);
	}

	// create a service */
	if (NULL_OB == (http = Http.dt_alloc_http_server(port))) {
	    System.err.println(name + ": dt_alloc_http_server failed\n");
	    System.exit(1);
	}

	for (;;) {
	    // receive a request */
	    xfer = Http.dt_http_get(http);

	    if (NULL_OB != xfer) {
		// send a response */
		Http.dt_http_put(xfer);
		Smiles.dt_dealloc(xfer);
	    }
	}
    }
}
