    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_depict.h>
#include "djutils.h"
#include "djDepict.h"

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1alloc_1conformation (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_alloc_conformation(ob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1alloc_1depiction (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_alloc_depiction(ob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1bondstyle (
    JNIEnv *env, jclass cls, jint ob, jint ah, jint bh) {
    return dt_bondstyle(ob, ah, bh);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1calcxy (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_calcxy(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1compressed (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_compressed(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1depict (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_depict(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1frame (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_frame(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1framega (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_framega(ob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1ga (
    JNIEnv *env, jclass cls, jint ob, jint ob2) {
    return dt_ga(ob, ob2);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1getcoord (
    JNIEnv *env, jclass cls, jint ob, jint ah, jfloatArray jfarrayx,
    jfloatArray jfarrayy, jfloatArray jfarrayz) {
    jboolean jret;
    float * xptr;
    float * yptr;
    float * zptr;

    xptr = GetFloatPtr(env, jfarrayx);
    yptr = GetFloatPtr(env, jfarrayy);
    zptr = GetFloatPtr(env, jfarrayz);
    jret = dt_getcoord(ob, ah, xptr, yptr, zptr);
    if (xptr) ReleaseFloatPtr(env, jfarrayx, xptr);
    if (yptr) ReleaseFloatPtr(env, jfarrayy, yptr);
    if (zptr) ReleaseFloatPtr(env, jfarrayz, zptr);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1isomeric (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_isomeric(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Depict_jdt_1label1 (
    JNIEnv *env, jclass cls, jint ob, jint ob2) {
    char * jret;
    int    jlen;

    jret = dt_label1(&jlen, ob, ob2);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1label1ga (
    JNIEnv *env, jclass cls, jint ob, jint ob2) {
    return dt_label1ga(ob, ob2);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Depict_jdt_1label2 (
    JNIEnv *env, jclass cls, jint ob, jint ob2) {
    char * jret;
    int    jlen;

    jret = dt_label2(&jlen, ob, ob2);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1label2ga (
    JNIEnv *env, jclass cls, jint ob, jint ob2) {
    return dt_label2ga(ob, ob2);
}

JNIEXPORT jint JNICALL Java_com_daylight_Depict_jdt_1orient (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_orient(ob);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1project (
    JNIEnv *env, jclass cls, jint ob, jint conf) {
    return dt_project(ob, conf) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1rotate (
    JNIEnv *env, jclass cls, jint ob,
    jfloat x, jfloat y, jfloat z, jfloat theta) {
    return dt_rotate(ob, x, y, z, theta) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1scale (
    JNIEnv *env, jclass cls, jint ob,
    jfloat cx, jfloat cy, jfloat cz) {
    return dt_scale(ob, cx, cy, cz) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1schematic (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_schematic(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setbondstyles (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_setbondstyles(ob) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setcompressed (
    JNIEnv *env, jclass cls, jint ob, jboolean v) {
    return dt_setcompressed(ob, (dt_Boolean) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setcoord (
    JNIEnv *env, jclass cls, jint ob, jint ah, 
    jfloat x, jfloat y, jfloat z) {
    return dt_setcoord(ob, ah, x, y, z) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setframe (
    JNIEnv *env, jclass cls, jint ob, jboolean v) {
    return dt_setframe(ob, (dt_Boolean) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setframega (
    JNIEnv *env, jclass cls, jint ob, jint v) {
    return dt_setframega(ob, (dt_Boolean) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setga (
    JNIEnv *env, jclass cls, jint ob, jint ob2, jint v) {
    return dt_setga(ob, ob2, (dt_Integer) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setisomeric (
    JNIEnv *env, jclass cls, jint ob, jint v) {
    return dt_setisomeric(ob, (dt_Integer) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setlabel1 (
    JNIEnv *env, jclass cls, jint ob, jint ob2, jstring jstr) {
    jboolean jret;
    char *str;

    str = GetCharPtr(env, jstr);
    jret = dt_setlabel1(ob, ob, str);
    if (str) ReleaseCharPtr(env, jstr, str);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setlabel1ga (
    JNIEnv *env, jclass cls, jint ob, jint ob2, jint v) {
    return dt_setlabel1ga(ob, ob2, (dt_Integer) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setlabel2 (
    JNIEnv *env, jclass cls, jint ob, jint ob2, jstring jstr) {
    jboolean jret;
    char * str;

    str = GetCharPtr(env, jstr);
    jret = dt_setlabel2(ob, ob, str);
    if (str) ReleaseCharPtr(env, jstr, str);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setlabel2ga (
    JNIEnv *env, jclass cls, jint ob, jint ob2, jint v) {
    return dt_setlabel2ga(ob, ob2, (dt_Integer) v ) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setorient (
    JNIEnv *env, jclass cls, jint ob, jint v) {
    return dt_setorient(ob, (dt_Integer) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1setschematic (
    JNIEnv *env, jclass cls, jint ob, jint v) {
    return dt_setschematic(ob, (dt_Integer) v) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1translate (
    JNIEnv *env, jclass cls, jint ob, jfloat x, jfloat y, jfloat z) {
    return dt_translate(ob, x, y, z) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Depict_jdt_1zerocoord (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_zerocoord(ob) ? JNI_TRUE : JNI_FALSE;
}
