    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_finger.h>
#include "djutils.h"
#include "djFinger.h"

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1allocfp (
    JNIEnv *env, jclass cls, jint size) {
    return dt_fp_allocfp(size);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1bitcount (
    JNIEnv *env, jclass cls, jint fp) {
    return dt_fp_bitcount(fp);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1bitvalue (
    JNIEnv *env, jclass cls, jint fp, jint bitno) {
    return dt_fp_bitvalue(fp, bitno);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1commonbitcount (
    JNIEnv *env, jclass cls, jint fp1, jint fp2) {
    return dt_fp_commonbitcount(fp1, fp2);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1differencefp (
    JNIEnv *env, jclass cls, jint ob, jint minsteps, jint steps,
    jint size) {
    return dt_fp_differencefp(ob, minsteps, steps, size);
}

JNIEXPORT jfloat JNICALL Java_com_daylight_Finger_jdt_1fp_1euclid (
    JNIEnv *env, jclass cls, jint fpth, jint fpoh) {
   return dt_fp_euclid(fpth, fpoh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1fingertest (
    JNIEnv *env, jclass cls, jint fpth, jint fpoh) {
   return dt_fp_fingertest(fpth, fpoh);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Finger_jdt_1fp_1foldfp (
    JNIEnv *env, jclass cls, jint fp, jint minsize, jfloat mindensity) {
    return dt_fp_foldfp(fp, minsize, mindensity) ? JNI_TRUE : JNI_FALSE;

}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1generatefp (
    JNIEnv *env, jclass cls, jint ob, jint min, jint max,
    jint size) {
printf("%s:%d %d %d %d %d\n", __FILE__, __LINE__, ob, min, max, size);
    return dt_fp_generatefp(ob, min, max, size);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1nbits (
    JNIEnv *env, jclass cls, jint fp) {
    return dt_fp_nbits(fp);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1obitcount (
    JNIEnv *env, jclass cls, jint fp) {
    return dt_fp_obitcount(fp);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1obits (
    JNIEnv *env, jclass cls, jint fp) {
    return dt_fp_obits(fp);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1partfp (
    JNIEnv *env, jclass cls, jint part, jint ob, jint min, jint max,
    jint size) {
    return dt_fp_partfp(part, ob, min, max, size);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Finger_jdt_1fp_1range (
    JNIEnv *env, jclass cls, jint fp, jint offset, jint nbits,
    jintArray soffset) {
    char *jret;
    int   jlen, *iptr, ilen, ival;
    
    iptr = GetIntPtrLen(env, &ilen, soffset);
    ilen && (ival = *iptr);
    jret = dt_fp_range(&jlen, fp, offset, nbits, &ival);
    ilen && (*iptr = ival);
    if (iptr) ReleaseIntPtr(env, soffset, iptr);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Finger_jdt_1fp_1setbitvalue (
    JNIEnv *env, jclass cls, jint fp, jint bitno, jboolean value) {
    return dt_fp_setbitvalue(fp, bitno, (value==JNI_TRUE)) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Finger_jdt_1fp_1setobitcount (
    JNIEnv *env, jclass cls, jint fp, jint obitcount) {
    return dt_fp_setobitcount(fp, obitcount) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Finger_jdt_1fp_1setobits (
    JNIEnv *env, jclass cls, jint fp, jint obits) {
    return dt_fp_setobits(fp, obits) ? JNI_TRUE : JNI_FALSE;

}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1setrange (
    JNIEnv *env, jclass cls, jint fp, jint offset, jint nbits,
    jstring jstr, jint soffset, jint operation) {
    jint jret;
    char *str;
    int   len;

    str = GetCharPtrLen(env, &len, jstr);
    jret = dt_fp_setrange(fp, offset, nbits, len, str, soffset, operation);
    if (str) ReleaseCharPtr(env, jstr, str);
    return jret;

}

/* v4.9
JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1similarity (
    JNIEnv *env, jclass cls, jint fpth, jint fpoh, jstring jstr) {
    jint jret;
    char *str;
    int   len;

    str = GetCharPtrLen(env, &len, jstr);
    jret = dt_fp_similarity(fpth, fpoh, len, str);
    if (str) ReleaseCharPtr(env, jstr, str);
    return jret;
}
*/

JNIEXPORT jfloat JNICALL Java_com_daylight_Finger_jdt_1fp_1tanimoto (
   JNIEnv *env, jclass cls, jint fpth, jint fpoh) {
    return dt_fp_tanimoto(fpth, fpoh);
}

JNIEXPORT jfloat JNICALL Java_com_daylight_Finger_jdt_1fp_1tversky (
    JNIEnv *env, jclass cls, jint fpa, jint fpb, jfloat alpha,
    jfloat beta) {
    return dt_fp_tversky(fpa, fpb, alpha, beta);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1alloc (
    JNIEnv *env, jclass cls) {
    return dt_fp_alloc();
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1fingerprint (
    JNIEnv *env, jclass cls, jint molh, jboolean dofold) {
    return dt_fp_fingerprint(molh, (dofold==JNI_TRUE));
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Finger_jdt_1fp_1fold (
    JNIEnv *env, jclass cls, jint fp) {
    return dt_fp_fold(fp) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jfloat JNICALL Java_com_daylight_Finger_jdt_1fp_1mindensity (
    JNIEnv *env, jclass cls) {
    return dt_fp_mindensity();
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1minsize (
    JNIEnv *env, jclass cls) {
    return dt_fp_minsize();
}

JNIEXPORT jfloat JNICALL Java_com_daylight_Finger_jdt_1fp_1setmindensity (
    JNIEnv *env, jclass cls, jfloat d) {
    return dt_fp_setmindensity(d);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1setminsize (
    JNIEnv *env, jclass cls, jint bits) {
    return dt_fp_setminsize(bits);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1setsize (
    JNIEnv *env, jclass cls, jint bits) {
    return dt_fp_setsize(bits);
}

JNIEXPORT jint JNICALL Java_com_daylight_Finger_jdt_1fp_1size (
    JNIEnv *env, jclass cls) {
    return dt_fp_size();
}

