    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_merlin.h>
#include "djutils.h"
#include "djMerlin.h"

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1server (
    JNIEnv *env, jclass cls, jstring host, jstring service,
    jstring userid, jstring password, jintArray isnew) {
    jint jret;
    char *hptr, *sptr, *uptr, *pptr;
    int   hlen,  slen,  ulen,  plen, *iptr, ilen, ival;

    hptr = GetCharPtrLen(env, &hlen, host);
    sptr = GetCharPtrLen(env, &slen, service);
    uptr = GetCharPtrLen(env, &ulen, userid);
    pptr = GetCharPtrLen(env, &plen, password);
    iptr = GetIntPtrLen(env, &ilen, isnew);
    ilen && (ival = *iptr);
    jret = dt_mer_server(hlen, hptr, slen, sptr, ulen, uptr, plen, pptr, &ival);
    if (hptr) ReleaseCharPtr(env, host, hptr);
    if (sptr) ReleaseCharPtr(env, service, sptr);
    if (uptr) ReleaseCharPtr(env, userid, uptr);
    if (pptr) ReleaseCharPtr(env, password, pptr);
    ilen && (*iptr = ival);
    if (iptr) ReleaseIntPtr(env, isnew, iptr);
    return jret;

}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1action2name (
    JNIEnv *env, jclass cls, jint serverh, jint iaction) {
    char * jret;
    int    jlen;

    jret = dt_mer_action2name( &jlen, serverh, iaction);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1function2name (
    JNIEnv *env, jclass cls, jint serverh, jint ifunc) {
    char * jret;
    int    jlen;

    jret = dt_mer_function2name(&jlen, serverh, ifunc);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1search2name (
    JNIEnv *env, jclass cls, jint serverh, jint isearch) {
    char * jret;
    int    jlen;

    jret = dt_mer_search2name(&jlen, serverh, isearch);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1similar2name (
    JNIEnv *env, jclass cls, jint serverh, jint isimilar) {
    char * jret;
    int    jlen;

    jret = dt_mer_similar2name(&jlen, serverh, isimilar);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1sort2name (
    JNIEnv *env, jclass cls, jint serverh, jint isort) {
    char * jret;
    int    jlen;

    jret = dt_mer_sort2name(&jlen, serverh, isort);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1subselect2name (
    JNIEnv *env, jclass cls, jint serverh, jint isubselect) {
    char * jret;
    int    jlen;

    jret = dt_mer_subselect2name(&jlen, serverh, isubselect);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1superselect2name (
    JNIEnv *env, jclass cls, jint serverh, jint isuperselect) {
    char * jret;
    int    jlen;

    jret = dt_mer_superselect2name(&jlen, serverh, isuperselect);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1progob2name (
    JNIEnv *env, jclass cls, jint serverh, jint iprogob) {
    char * jret;
    int    jlen;

    jret = dt_mer_progob2name(&jlen, serverh, iprogob);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nactions (
    JNIEnv *env, jclass cls, jint serverh) {
    return dt_mer_nactions(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nfunctions (
    JNIEnv *env, jclass cls, jint serverh) {
    return dt_mer_nfunctions(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nsearches (
    JNIEnv *env, jclass cls, jint serverh) {
    return dt_mer_nsearches(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nsimilars (
    JNIEnv *env, jclass cls, jint serverh) {
    return dt_mer_nsimilars(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nsorts (
    JNIEnv *env, jclass cls, jint serverh) {
    jint jret;
    return dt_mer_nsorts(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nsubselects (
    JNIEnv *env, jclass cls, jint serverh) {
   jint jret;
   return dt_mer_nsubselects(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nsuperselects (
    JNIEnv *env, jclass cls, jint serverh) {
    return dt_mer_nsuperselects(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1nprogobs (
    JNIEnv *env, jclass cls, jint serverh) {
    return dt_mer_nprogobs(serverh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1getnitems (
    JNIEnv *env, jclass cls, jint pool, jint dtype) {
    return dt_mer_getnitems(pool, dtype);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1alloc_1column (
    JNIEnv *env, jclass cls, jint poolh, jint ftype, jint functype) {
    return dt_mer_alloc_column(poolh, ftype, functype);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1function (
    JNIEnv *env, jclass cls, jint col) {
    return dt_mer_function(col);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1alloc_1hitlist (
    JNIEnv *env, jclass cls, jint poolh) {
    return dt_mer_alloc_hitlist(poolh);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1clear (
    JNIEnv *env, jclass cls, jint hit) {
    return dt_mer_clear(hit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1combinehitlists (
    JNIEnv *env, jclass cls, jint hit1, jint hh2, jint action) {
    return dt_mer_combinehitlists(hit1, hh2, action);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1hit2id (
    JNIEnv *env, jclass cls, jint hit, jint ihit) {
    return dt_mer_hit2id(hit, ihit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1id2hit (
    JNIEnv *env, jclass cls, jint hit, jint id) {
    jint jret;
    return dt_mer_id2hit(hit, id);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1invert (
    JNIEnv *env, jclass cls, jint hit) {
    return dt_mer_invert(hit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1length (
    JNIEnv *env, jclass cls, jint hit) {
    return dt_mer_length(hit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1mvbottom (
    JNIEnv *env, jclass cls, jint hit, jint ihit) {
    return dt_mer_mvbottom(hit, ihit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1mvtop (
    JNIEnv *env, jclass cls, jint hit, jint ihit) {
    return dt_mer_mvtop(hit, ihit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1native (
    JNIEnv *env, jclass cls, jint hit) {
    return dt_mer_native(hit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1reset (
    JNIEnv *env, jclass cls, jint hit) {
    return dt_mer_reset(hit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1reverse (
    JNIEnv *env, jclass cls, jint hit) {
    return dt_mer_reverse(hit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1sethits (
    JNIEnv *env, jclass cls, jint hit, jint ch, jint sq) {
    return dt_mer_sethits(hit, ch, sq);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1zapabove (
    JNIEnv *env, jclass cls, jint hit, jint ihit) {
    return dt_mer_zapabove(hit, ihit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1zapbelow (
    JNIEnv *env, jclass cls, jint hit, jint ihit) {
    return dt_mer_zapbelow(hit, ihit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1zapna (
    JNIEnv *env, jclass cls, jint hit, jint col) {
    return dt_mer_zapna(hit, col);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1zapnonunique (
    JNIEnv *env, jclass cls, jint hit, jint col) {
    return dt_mer_zapnonunique(hit, col);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1sort (
    JNIEnv *env, jclass cls, jint hit, jint col, jint sort,
    jint ascending, jintArray pret_status) {
    jint jret;
    int  *sptr;
    int   slen, sval;

    sptr = GetIntPtrLen(env, &slen, pret_status);
    slen && (sval = *sptr);
    jret = dt_mer_sort(hit, col, sort, ascending, &sval);
    slen && (*sptr = sval);
    if (sptr) ReleaseIntPtr(env, pret_status, sptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1strsearch (
    JNIEnv *env, jclass cls, jint hit, jint col, jint search,
    jint action, jint find_next, jintArray rstatus, jstring s1, jstring s2) {
    jint jret;
    char *sptr1, *sptr2;
    int   slen1,  slen2, *rptr, rlen, rval;

    rptr = GetIntPtrLen(env, &rlen, rstatus);
    rlen && (rval = *rptr);
    sptr1 = GetCharPtrLen(env, &slen1, s1);
    sptr2 = GetCharPtrLen(env, &slen2, s2);
    jret = dt_mer_strsearch(hit, col, search, action, find_next,
			    &rval, slen1, sptr1, slen2, sptr2);
    rlen && (*rptr = rval);
    if (rptr) ReleaseIntPtr(env, rstatus, rptr);
    if (sptr1) ReleaseCharPtr(env, s1, sptr1);
    if (sptr2) ReleaseCharPtr(env, s2, sptr2);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1numsearch (
    JNIEnv *env, jclass cls, jint hit, jint col, jint action,
    jint find_next, jintArray rstatus, jfloat low, jfloat high) {
    jint jret;
    int  *rptr;
    int   rlen, rval;

    rptr = GetIntPtrLen(env, &rlen, rstatus);
    rlen && (rval = *rptr);
    jret = dt_mer_numsearch(hit, col, action, find_next, &rval, low, high);
    rlen && (*rptr = rval);
    if (rptr) ReleaseIntPtr(env, rstatus, rptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1subselect (
    JNIEnv *env, jclass cls, jint hit, jint col, jint searchtype,
    jint action, jint find_next, jintArray rstatus, jstring smiles) {
    jint jret;
    char *sptr;
    int   slen, *rptr, rlen, rval;

    rptr = GetIntPtrLen(env, &rlen, rstatus);
    rlen && (rval = *rptr);
    sptr = GetCharPtrLen(env, &slen, smiles);
    jret = dt_mer_subselect(hit, col, searchtype, action, find_next,
			    &rval, slen, sptr);
    rlen && (*rptr = rval);
    if (rptr) ReleaseIntPtr(env, rstatus, rptr);
    if (sptr) ReleaseCharPtr(env, smiles, sptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1superselect (
    JNIEnv *env, jclass cls, jint hit, jint col, jint searchtype,
    jint action, jint find_next, jintArray rstatus, jstring smiles) {
    jint jret;
    char *sptr;
    int   slen, *rptr, rlen, rval;

    rptr = GetIntPtrLen(env, &rlen, rstatus);
    rlen && (rval = *rptr);
    sptr = GetCharPtrLen(env, &slen, smiles);
    jret = dt_mer_superselect(hit, col, searchtype, action, find_next,
			      &rval, slen, sptr);
    rlen && (*rptr = rval);
    if (rptr) ReleaseIntPtr(env, rstatus, rptr);
    if (sptr) ReleaseCharPtr(env, smiles, sptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1similarselect (
    JNIEnv *env, jclass cls, jint hit, jint col, jint similartype,
    jint action, jint find_next, jintArray rstatus, jstring smiles,
    jfloat limit, jfloat alpha, jfloat beta) {
    jint jret;
    char *sptr;
    int   slen, *rptr,  rlen, rval;

    rptr = GetIntPtrLen(env, &rlen, rstatus);
    rlen && (rval = *rptr);
    sptr = GetCharPtrLen(env, &slen, smiles);
    jret = dt_mer_similarselect(hit, col, similartype, action, find_next,
				&rval, slen, sptr, limit, alpha, beta);
    rlen && (*rptr = rval);
    if (rptr) ReleaseIntPtr(env, rstatus, rptr);
    if (sptr) ReleaseCharPtr(env, smiles, sptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1progob_1compare (
    JNIEnv *env, jclass cls, jint hit, jint target_col,
    jint results_col, jint iprogob, jint pattern_bin, jint parameters,
    jintArray pstatus) {
    jint jret;
    int  *pptr;
    int   plen, pval;

    pptr = GetIntPtrLen(env, &plen, pstatus);
    plen && (pval = *pptr);
    jret = dt_mer_progob_compare(hit, target_col, results_col, iprogob,
				 pattern_bin, parameters, &pval);
    plen && (*pptr = pval);
    if (pptr) ReleaseIntPtr(env, pstatus, pptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1progob_1compute (
    JNIEnv *env, jclass cls, jint poolh, jint iprogob, jint strobj,
    jint parms) {
    return dt_mer_progob_compute(poolh, iprogob, strobj, parms);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1progob_1computeparams (
    JNIEnv *env, jclass cls, jint poolh, jint iprogob) {
    return dt_mer_progob_computeparams(poolh, iprogob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1progob_1compareparams (
    JNIEnv *env, jclass cls, jint poolh, jint iprogob) {
    return dt_mer_progob_compareparams(poolh, iprogob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1similar (
    JNIEnv *env, jclass cls, jint hit, jint col, jint similartype,
    jint action, jint find_next, jintArray rstatus, jstring smiles,
    jfloat limit) {
    jint jret;
    char *sptr;
    int   slen, *rptr, rlen, rval;

    rptr = GetIntPtrLen(env, &rlen, rstatus);
    rlen && (rval = *rptr);
    sptr = GetCharPtrLen(env, &slen, smiles);
    jret = dt_mer_similar(hit, col, similartype, action, find_next,
			  &rval, slen, sptr, (float) limit);
    rlen && (*rptr = rval);
    if (rptr) ReleaseIntPtr(env, rstatus, rptr);
    if (sptr) ReleaseCharPtr(env, smiles, sptr);
    return jret;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1cellvalue (
    JNIEnv *env, jclass cls, jint col, jint hit, jint ihit) {
    char *jret;
    int   jlen;

    jret = dt_mer_cellvalue(&jlen, col, hit, ihit);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1getdata (
    JNIEnv *env, jclass cls, jint hit, jint ihit, jint ftype, jint nth) {
    char *jret;
    int   jlen;

    jret = dt_mer_getdata(&jlen, hit, ihit, ftype, nth);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Merlin_jdt_1mer_1getroot (
    JNIEnv *env, jclass cls, jint hh, jint ihit) {
    char *jret;
    int   jlen;

    jret = dt_mer_getroot(&jlen, hh, ihit);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Merlin_jdt_1mer_1defaultsort (
    JNIEnv *env, jclass cls, jint col) {
    return dt_mer_defaultsort(col);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Merlin_jdt_1mer_1sortapplies (
    JNIEnv *env, jclass cls, jint col, jint sort) {
    return dt_mer_sortapplies(col, sort) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Merlin_jdt_1mer_1funcapplies (
    JNIEnv *env, jclass cls, jint ftype, jint function) {
    return dt_mer_funcapplies(ftype, function) ? JNI_TRUE : JNI_FALSE;
}

