    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_smarts.h>
#include "djutils.h"
#include "djSmarts.h"

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1alloc_1pathset (
    JNIEnv *env, jclass cls, jint m) {
    return dt_alloc_pathset(m);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1alloc_1vbind (
    JNIEnv *env, jclass cls, jstring s) {
    jint jret;
    char *sptr;
    int   slen;

    sptr = GetCharPtrLen(env, &slen, s);
    jret = dt_alloc_vbind(slen, sptr);
    if (sptr) ReleaseCharPtr(env, s, sptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1getval (
    JNIEnv *env, jclass cls, jint ob) {
    return dt_getval(ob);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1match (
    JNIEnv *env, jclass cls, jint ob, jint mol, jint exists) {
    return dt_match(ob, mol, exists);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1pattern (
    JNIEnv *env, jclass cls, jint transform, jint role) {
    return dt_pattern(transform, role);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Smarts_jdt_1setval (
    JNIEnv *env, jclass cls, jint ob, jint val) {
    return dt_setval(ob, val) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1smartin (
    JNIEnv *env, jclass cls, jstring s) {
    jint jret;
    char *sptr;
    int   slen;

    sptr = GetCharPtrLen(env, &slen, s);
    jret = dt_smartin(slen, sptr);
    if (sptr) ReleaseCharPtr(env, s, sptr);
    return jret;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Smarts_jdt_1smarts_1opt (
    JNIEnv *env, jclass cls, jstring string, jboolean vmatch) {
    char *jret, *sptr;
    int   jlen,  slen;

    sptr = GetCharPtrLen(env, &slen, string);
    jret = dt_smarts_opt(&jlen, slen, sptr, (vmatch==JNI_TRUE));
    if (sptr) ReleaseCharPtr(env, string, sptr);
    return String2Java(env, jlen, jret);

}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1smirkin (
    JNIEnv *env, jclass cls, jstring string) {
    jint jret;
    char *sptr;
    int   slen;

    sptr = GetCharPtrLen(env, &slen, string);
    jret = dt_smirkin(slen, sptr);
    if (sptr) ReleaseCharPtr(env, string, sptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1transform (
    JNIEnv *env, jclass cls, jint transform, jint som,
    jboolean direction, jint limit) {
    return dt_transform(transform, som, (direction==JNI_TRUE), limit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1utransform (
    JNIEnv *env, jclass cls, jint transform, jint som,
    jboolean direction, jint limit) {
    return dt_utransform(transform, som, (direction==JNI_TRUE), limit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1xtransform (
    JNIEnv *env, jclass cls, jint transform, jint som,
    jboolean direction, jint limit) {
    return dt_xtransform(transform, som, (direction==JNI_TRUE), limit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1umatch (
    JNIEnv *env, jclass cls, jint ob, jint mol, jint ex) {
    return dt_umatch(ob, mol, ex);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1vmatch (
    JNIEnv *env, jclass cls, jint ob, jint mol, jint ex) {
    return dt_vmatch(ob, mol, ex);
}

JNIEXPORT jint JNICALL Java_com_daylight_Smarts_jdt_1xmatch (
    JNIEnv *env, jclass cls, jint ob, jint mol, jint ex) {
    return dt_xmatch(ob, mol, ex);
}
