    /**********************************************************************
    * This source code is public domain, and may be freely distributed,   *
    * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
    * WARRANTY OF ANY KIND.                                               *
    **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <dt_smiles.h>
#include <dt_thor.h>
#include "djutils.h"
#include "djThor.h"

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1alloc_1dataitem (
    JNIEnv *env, jclass cls, jint tdt, jint dtype) {
    return dt_thor_alloc_dataitem(tdt, dtype);
}

JNIEXPORT jfloat JNICALL Java_com_daylight_Thor_jdt_1thor_1autocrunch_1limit (
    JNIEnv *env, jclass cls, jint db, jfloat limit) {
    return dt_thor_autocrunch_limit(db, limit);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1cache (
    JNIEnv *env, jclass cls, jint db, jint level) {
    return dt_thor_cache(db, level);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1cachecontrol (
    JNIEnv *env, jclass cls, jint db, jint when, jint level) {
    return dt_thor_cachecontrol(db, when, level);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1cachesync (
    JNIEnv *env, jclass cls, jint db) {
    return dt_thor_cachesync(db);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1createdb (
    JNIEnv *env, jclass cls, jint server, jstring path,
    jint size_d, jint size_x) {
    jint jret;
    char *pptr;
    int   plen;

    pptr = GetCharPtrLen(env, &plen, path);
    jret = dt_thor_createdb(server, plen, pptr, size_d, size_x);
    if (pptr) ReleaseCharPtr(env, path, pptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1crunchdata (
    JNIEnv *env, jclass cls, jint db) {
    return dt_thor_crunchdata(db);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1crunchxref (
    JNIEnv *env, jclass cls, jint db) {
    return dt_thor_crunchxref(db);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Thor_jdt_1thor_1destroy (
    JNIEnv *env, jclass cls, jint svh, jstring path,
    jstring password) {
    jboolean jret;
    char *pptr;
    int   plen;
    char *wptr;
    int   wlen;

    pptr = GetCharPtrLen(env, &plen, path);
    wptr = GetCharPtrLen(env, &wlen, password);
    jret = dt_thor_destroy(svh, plen, pptr, wlen, wptr);
    if (pptr) ReleaseCharPtr(env, path, pptr);
    if (wptr) ReleaseCharPtr(env, password, wptr);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1indirect_1hint (
   JNIEnv *env, jclass cls, jint db, jint hint) {
    return dt_thor_indirect_hint(db, hint);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1getauxillarydb (
    JNIEnv *env, jclass cls, jint db, jint which_db) {
    char *jret;
    int   jlen;

    jret = dt_thor_getauxillarydb(&jlen, db, which_db);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1moveitem (
    JNIEnv *env, jclass cls, jint moveh, jint afterh) {
    return dt_thor_moveitem(moveh, afterh);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1raw_1datafield (
    JNIEnv *env, jclass cls, jint dfh) {
    char *jret;
    int   jlen;

    jret = dt_thor_raw_datafield(&jlen, dfh);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Thor_jdt_1thor_1readonly (
    JNIEnv *env, jclass cls, jint db) {
    return dt_thor_readonly(db) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1server (
    JNIEnv *env, jclass cls, jstring host, jstring service, jstring user, jstring passwd, jintArray isnew) {
    jint jret;
    char *hptr;
    int   hlen;
    char *sptr;
    int   slen;
    char *uptr;
    int   ulen;
    char *wptr;
    int   wlen;
    int  *iptr;
    int   ilen, ival;

    hptr = GetCharPtrLen(env, &hlen, host);
    sptr = GetCharPtrLen(env, &slen, service);
    uptr = GetCharPtrLen(env, &ulen, user);
    wptr = GetCharPtrLen(env, &wlen, passwd);
    iptr = GetIntPtrLen(env, &ilen, isnew);
    ilen && (ival = *iptr);
    jret = dt_thor_server(hlen, hptr, slen, sptr, ulen, uptr, wlen, wptr, &ival);
    if (hptr) ReleaseCharPtr(env, host, hptr);
    if (sptr) ReleaseCharPtr(env, service, sptr);
    if (uptr) ReleaseCharPtr(env, user, uptr);
    if (wptr) ReleaseCharPtr(env, passwd, wptr);
    ilen && (*iptr = ival);
    if (iptr) ReleaseIntPtr(env, isnew, iptr);
    return jret;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Thor_jdt_1thor_1setauxillarydb (
    JNIEnv *env, jclass cls, jint db, jint which_db, 
    jstring path) {
    jboolean jret;
    char *pptr;
    int   plen;

    pptr = GetCharPtrLen(env, &plen, path);
    jret = dt_thor_setauxillarydb(db, which_db, plen, pptr);
    if (pptr) ReleaseCharPtr(env, path, pptr);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Thor_jdt_1thor_1setreadonly (
    JNIEnv *env, jclass cls, jint db, jstring password, 
    jboolean readonly) {
    jboolean jret;
    char *wptr;
    int   wlen;

    wptr = GetCharPtrLen(env, &wlen, password);
    jret = dt_thor_setreadonly(db, wlen, wptr, (readonly==JNI_TRUE));
    if (wptr) ReleaseCharPtr(env, password, wptr);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Thor_jdt_1thor_1settdtlocking (
     JNIEnv *env, jclass cls, jint db, jstring password, 
     jboolean tdtlocking) {
    jboolean jret;
    char *wptr;
    int   wlen;

    wptr = GetCharPtrLen(env, &wlen, password);
    jret = dt_thor_settdtlocking(db, wlen, wptr, (tdtlocking==JNI_TRUE));
    if (wptr) ReleaseCharPtr(env, password, wptr);
    return jret ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1str2tdt (
    JNIEnv *env, jclass cls, jint db, jstring jstr, jint merge) {
    jint jret;
    char *str;
    int   len;

    str = GetCharPtrLen(env, &len, jstr);
    jret = dt_thor_str2tdt(db, len, str, merge);
    if (str) ReleaseCharPtr(env, jstr, str);
    return jret;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1tdt2str (
    JNIEnv *env, jclass cls, jint tdt, jint exp) {
    char *jret;
    int   jlen;

    jret = dt_thor_tdt2str(&jlen, tdt, exp);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jboolean JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtlocking (
    JNIEnv *env, jclass cls, jint db) {
    return dt_thor_tdtlocking(db) ? JNI_TRUE : JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtget (
    JNIEnv *env, jclass cls, jint parenth, jint dtype, jstring id, jint writeable, jintArray pnew) {
    jint jret;
    char *iptr;
    int   ilen;
    int  *_pnew;
    int   _len_pnew;
    int   _val_pnew;

    iptr = GetCharPtrLen(env, &ilen, id);
    _pnew = GetIntPtrLen(env, &_len_pnew, pnew);
    _len_pnew && (_val_pnew = *_pnew);
    jret = dt_thor_tdtget(parenth, dtype, ilen, iptr, writeable, &_val_pnew);
    if (iptr) ReleaseCharPtr(env, id, iptr);
    _len_pnew && (*_pnew = _val_pnew);
    if (_pnew) ReleaseIntPtr(env, pnew, _pnew);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtget_1raw (
    JNIEnv *env, jclass cls, jint db, jstring tag, 
    jstring id, jboolean writeable) {
    jint jret;
    char *tptr;
    int   tlen;
    char *iptr;
    int   ilen;

    tptr = GetCharPtrLen(env, &tlen, tag);
    iptr = GetCharPtrLen(env, &ilen, id);
    jret = dt_thor_tdtget_raw(db, tlen, tptr, ilen, iptr, (writeable==JNI_TRUE));
    if (tptr) ReleaseCharPtr(env, tag, tptr);
    if (iptr) ReleaseCharPtr(env, id, iptr);
    return jret;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtlockedby (
    JNIEnv *env, jclass cls, jint dtype, jstring id) {
    char *jret;
    int   jlen;
    char *iptr;
    int   ilen;

    iptr = GetCharPtrLen(env, &ilen, id);
    jret = dt_thor_tdtlockedby(&jlen, dtype, ilen, iptr);
    if (iptr) ReleaseCharPtr(env, id, iptr);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtmerge (
    JNIEnv *env, jclass cls, jint t1h, jint t2h) {
    return dt_thor_tdtmerge(t1h, t2h);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtremove (
    JNIEnv *env, jclass cls, jint tdt) {
    return dt_thor_tdtremove(tdt);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtremove_1raw (
    JNIEnv *env, jclass cls, jint db, jstring tag, jstring id) {
    jint jret;
    char *tptr;
    int   tlen;
    char *iptr;
    int   ilen;

    tptr = GetCharPtrLen(env, &tlen, tag);
    iptr = GetCharPtrLen(env, &ilen, id);
    jret = dt_thor_tdtremove_raw(db, tlen, tptr, ilen, iptr);
    if (tptr) ReleaseCharPtr(env, tag, tptr);
    if (iptr) ReleaseCharPtr(env, id, iptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtput (
    JNIEnv *env, jclass cls, jint tdt, jint how) {
    return dt_thor_tdtput(tdt, how);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtput_1raw (
    JNIEnv *env, jclass cls, jint db, jstring tdtstr, jint how) {
    jint jret;
    char *tptr;
    int   tlen;

    tptr = GetCharPtrLen(env, &tlen, tdtstr);
    jret = dt_thor_tdtput_raw(db, tlen, tptr, how);
    if (tptr) ReleaseCharPtr(env, tdtstr, tptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtrevise (
    JNIEnv *env, jclass cls, jint tdt) {
    return dt_thor_tdtrevise(tdt);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1xrefget (
    JNIEnv *env, jclass cls, jint db, jint dtype, jstring id,
    jintArray perror) {
    jint jret;
    char *iptr;
    int   ilen;
    int  *eptr;
    int   elen;
    int   eval;

    iptr = GetCharPtrLen(env, &ilen, id);
    eptr = GetIntPtrLen(env, &elen, perror);
    elen && (eval = *eptr);
    jret = dt_thor_xrefget(db, dtype, ilen, iptr, &eval);
    if (iptr) ReleaseCharPtr(env, id, iptr);
    elen && (*eptr = eval);
    if (eptr) ReleaseIntPtr(env, perror, eptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1connect (
   JNIEnv *env, jclass cls, jstring host, jstring service, jstring userid, jstring password) {
   jint jret;
   char *hptr;
   char *sptr;
   char *uptr;
   char *wptr;

   hptr = GetCharPtr(env, host);
   sptr = GetCharPtr(env, service);
   uptr = GetCharPtr(env, userid);
   wptr = GetCharPtr(env, password);
   jret = dt_thor_connect(hptr, sptr, uptr, wptr);
   if (hptr) ReleaseCharPtr(env, host, hptr);
   if (sptr) ReleaseCharPtr(env, service, sptr);
   if (uptr) ReleaseCharPtr(env, userid, uptr);
   if (wptr) ReleaseCharPtr(env, password, wptr);
   return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1add_1directory (
    JNIEnv *env, jclass cls, jint server, jstring passwd,
    jstring dir) {
    jint jret;
    char *wptr;
    char *dptr;

    wptr = GetCharPtr(env, passwd);
    dptr = GetCharPtr(env, dir);
    jret = dt_thor_add_directory(server, wptr, dptr);
    if (wptr) ReleaseCharPtr(env, passwd, wptr);
    if (dptr) ReleaseCharPtr(env, dir, dptr);
    return jret;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1list_1directories (
    JNIEnv *env, jclass cls, jint sh) {
    char *jret;
    int   jlen;

    jret = dt_thor_list_directories(&jlen, sh);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1open (
    JNIEnv *env, jclass cls, jint sh, jstring path, jstring perm, jstring passwd) {
    jint jret;
    char *pptr;
    char *eptr;
    char *wptr;

    pptr = GetCharPtr(env, path);
    eptr = GetCharPtr(env, perm);
    wptr = GetCharPtr(env, passwd);
    jret = dt_thor_open(sh, pptr, eptr, wptr);
    if (pptr) ReleaseCharPtr(env, path, pptr);
    if (eptr) ReleaseCharPtr(env, perm, eptr);
    if (wptr) ReleaseCharPtr(env, passwd, wptr);
    return jret;

}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1list_1databases (
    JNIEnv *env, jclass cls, jint sh) {
    char *jret;
    int   jlen;

    jret = dt_thor_list_databases(&jlen, sh);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1set_1dtypes_1db (
    JNIEnv *env, jclass cls, jint db, jstring path) {
    jint jret;
    char *pptr;

    pptr = GetCharPtr(env, path);
    jret = dt_thor_set_dtypes_db(db, pptr);
    if (pptr) ReleaseCharPtr(env, path, pptr);
    return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1set_1indir_1db (
    JNIEnv *env, jclass cls, jint db, jstring path) {
   jint jret;
   char *pptr;

   pptr = GetCharPtr(env, path);
   jret = dt_thor_set_indir_db(db, pptr);
   if (pptr) ReleaseCharPtr(env, path, pptr);
   return jret;
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1dtypes_1db (
    JNIEnv *env, jclass cls, jint db) {
    char *jret;
    int   jlen;

    jret = dt_thor_dtypes_db(&jlen, db);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jstring JNICALL Java_com_daylight_Thor_jdt_1thor_1indir_1db (
    JNIEnv *env, jclass cls, jint db) {
    char *jret;
    int   jlen;

    jret = dt_thor_indir_db(&jlen, db);
    return String2Java(env, jlen, jret);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1create (
    JNIEnv *env, jclass cls, jint svh, jstring path,
    jint size_d, jint size_x, jint nd, jint nx) {
    jint jret;
    char *pptr;

   pptr = GetCharPtr(env, path);
   jret = dt_thor_create(svh, pptr, size_d, size_x, nd, nx);
   if (pptr) ReleaseCharPtr(env, path, pptr);
   return jret;
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtdelete (
    JNIEnv *env, jclass cls, jint tdt) {
    return dt_thor_tdtdelete(tdt);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtputforced (
    JNIEnv *env, jclass cls, jint tdt, jint merge) {
    return dt_thor_tdtputforced(tdt, merge);
}

JNIEXPORT jint JNICALL Java_com_daylight_Thor_jdt_1thor_1tdtputraw (
    JNIEnv *env, jclass cls, jint db, jstring jstr) {
    jint jret;
    char *str;
    int   len;

    str = GetCharPtrLen(env, &len, jstr);
    jret = dt_thor_tdtputraw(db, len, str);
    if (str) ReleaseCharPtr(env, jstr, str);
    return jret;
}
