//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;
import com.daylight.Thor;
import com.daylight.Merlin;

class merlinls extends Smiles {
    public static void main(String[] args) throws IOException {
	PrintWriter out = new PrintWriter(System.out, true);
	String host, service, username, password, dataname;
	int i, j, server, isnew[] = new int[1], container, database;
	byte[] value;

	// initialize
	host = "localhost";
	service = "merlin";
	username = "thorinfo";
	password = "";

	// arguments
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new merlinls().getClass().getName() +
				   " [ host service username password ]");
		System.exit(0);
	    }
	    if (1 <= args.length)
		host = args[0];
	    if (2 <= args.length)
		service = args[1];
	    if (3 <= args.length)
		username = args[2];
	    if (4 <= args.length)
		password = args[3];
	}

	// get server
	if (NULL_OB == (server = Merlin.dt_mer_server
			(host, service, username, password, isnew))) {
	    System.err.println("ERROR: unable to access server (" +
			       host + ":" + service + ":" +
			       username + "%" + password + ")");
	    System.exit(1);
	}

	// get databases
	if (NULL_OB== (container = Smiles.dt_getdatabases(server)))
	    System.err.println("WARNING: dt_getdatabases failed");
	else {
	    while (NULL_OB != (database = dt_next(container))) {
		value = dt_stringvalue(database);
		dataname = new String(value);
		if (false == Smiles.dt_isopen(server, dataname))
		    continue;
		if (0 >= (i = dataname.lastIndexOf("/")))
		    i = 0;
		if (i >= (j = dataname.lastIndexOf(".")))
		    j = dataname.length();
		if ((-1 != dataname.indexOf("_datatypes")) ||
		    (-1 != dataname.indexOf("_indirect"))  ||
		    (-1 != dataname.indexOf("_monomers")))
		    continue;
		out.println("  " + dataname.substring(i+1, j));
	    }
	}

	// deallocate
	Smiles.dt_dealloc(server);

	// close I/O
        out.close();
   }
}
