//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;
import com.daylight.Progob;

class ptalk extends Smiles {
    public static void main(String[] args) throws IOException {
	String name = new ptalk().getClass().getName();
	BufferedReader in = new BufferedReader
	    (new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out, true);
	int i, program, object, container;
	String line;
	boolean help;
	byte[] value;

	// initialize
	help = false;

	// arguments
	if (0 == args.length)
	    help = true;
	else if (args[0].startsWith("-h"))
	    help = true;
	// help
	if (true == help) {
	    System.err.println("Usage: java " + name + " <program talker>");
	    System.err.println("Examples:");
	    System.err.println("  printf \"O\\nOc1ccc(O)cc1\\n\" | java " +
			       name + " fingertalk");
	    System.err.println("  printf \"O\\nOc1ccc(O)cc1\\n\" | java " +
			       name + " clogptalk");
	    System.err.println("  printf \"O\\nOc1ccc(O)cc1\\n\" | java " +
			       name + " cmrtalk");
	    System.err.println("  printf \"Qwerty: " +
			       "Set PROPERTY POLAR_SURFACE_AREA " +
			       "\\nO\\nOc1ccc(O)cc1\\n\" | java " +
			       name + " dayproptalk");
	    System.exit(0);
	}

	// create program object with a string object.  Use a
	// sequence of string objects to pass arguments. */
	if (NULL_OB == (object = Smiles.dt_alloc_string(args[0]))) {
	    System.err.println("ERROR: unable to allocate program name");
	    System.exit(1);
	}
	if (NULL_OB == (program = Progob.dt_alloc_program(object))) {
		System.err.println("ERROR: unable to allocate program object");
	    System.exit(1);
	}
	Smiles.dt_dealloc(object);

	// loop over input
	out.println("Reading input from stdin...");
        while (null != (line=in.readLine())) {

	    // put program input as a string or a sequence of strings */
	    if (NULL_OB == (object = Smiles.dt_alloc_string(line))){
		System.err.println("ERROR: unable to allocate input");
		continue;
	    }
	    if (NULL_OB == (container = Progob.dt_converse(program, object))) {
		System.err.println("ERROR: unable to converse");
		continue;
	    }
	    Smiles.dt_dealloc(object);

	    /* get program output as a sequence of strings */
	    i=0;
	    while (NULL_OB != (object = Smiles.dt_next(container))) {
		i++;
		if (null != (value = Smiles.dt_stringvalue(object)))
		    out.println(new String(value));
		Smiles.dt_dealloc(object);
	    }
	    if (0 == i)
		System.err.println("NOTE: no output (input \"" + line + "\")");
	    Smiles.dt_dealloc(container);
	}

	// close I/O
        out.close();
        in.close();
   }
}
