//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;

class cansmi extends Smiles {
    public static void main(String[] args) throws IOException {
	BufferedReader in = new BufferedReader
	    (new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out, true);
	boolean iso;
        String line, smiles;
        int molecule;

	// initialize
	iso = false;

	// arguments
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new cansmi().getClass().getName() +
				   " < input.smi");
		System.exit(0);
	    }
	    // isomeric
	    if (args[0].startsWith("-i"))
		iso = true;
	}

	// loop over input (read SMILES)
        while (null != (line=in.readLine())) {
	    // get molecule
	    if (NULL_OB == (molecule = Smiles.dt_smilin(line))) {
		System.err.println("ERROR: invalid SMILES (" + line + ")");
		continue;
	    }

	    // get canonical SMILES
	    if (null == (smiles = Smiles.dt_cansmiles(molecule, iso))) {
		System.err.println("ERROR: invalid molecule (" + line + ")");
		continue;
	    }

	    // show result and deallocate
	    out.println(smiles);
	    Smiles.dt_dealloc(molecule);

	    // voluntarily relinquish processor
	    Thread.yield();
	}

	// close I/O
        out.close();
        in.close();
    }
}
