//  /**********************************************************************
//  * This source code is public domain, and may be freely distributed,   *
//  * modified, and used for any purpose.  IT COMES WITH ABSOLUTELY NO    *
//  * WARRANTY OF ANY KIND.                                               *
//  **********************************************************************/

import java.io.*;
import com.daylight.Smiles;

class stringvalue extends Smiles {
    public static void main(String[] args) throws IOException {
	BufferedReader in = new BufferedReader
	    (new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out, true);
        String input;
	byte[] value;
	int object;

	// arguments
	if (0 < args.length) {
	    // help
	    if (args[0].startsWith("-h")) {
		System.err.println("Usage: java " +
				   new stringvalue().getClass().getName() +
				   " < input.txt");
		System.exit(0);
	    }
	}

	// loop over input (read text)
        while (null != (input=in.readLine())) {
	    // allocate object
	    if (NULL_OB == (object = Smiles.dt_alloc_string(input))){
		System.err.println("ERROR: unable to allocate string ("
				   + input + ")");
		continue;
	    }

	    // get string value
	    if (null == (value = Smiles.dt_stringvalue(object))) {
		System.err.println("ERROR: unable to retrieve string value ("
				   + input + ")");
		continue;
	    }

	    // show result
	    out.print(input + " -> " + new String(value));

	    // set & get string value
	    if (false == Smiles.dt_setstringvalue(object, input.getBytes())) {
		System.err.println("ERROR: unable to set string value");
		continue;
	    }
	    if (null == (value = Smiles.dt_stringvalue(object))) {
		System.err.println("ERROR: unable to get string value");
		continue;
	    }

	    // show result
	    out.print(" -> " + new String(value));

	    // set & get string value
	    if (false == Smiles.dt_appendstringvalue(object,
						     "-foobar".getBytes())) {
		System.err.println("ERROR: unable to append string value");
		continue;
	    }
	    if (null == (value = Smiles.dt_stringvalue(object))) {
		System.err.println("ERROR: unable to get appended value");
		continue;
	    }

	    // show result
	    out.println(" -> " + new String(value));

	    // deallocate
	    Smiles.dt_dealloc(object);

	    // voluntarily relinquish processor
	    Thread.yield();
	}

	// close I/O
        out.close();
        in.close();
    }
}
